using namespace std;
#include <GL/freeglut.h>
#include<stdio.h>
#include "fdtd.h"
#ifdef LINUX
#include <unistd.h>
#endif

FDTD mp;

void display()
{
	mp.display(); 
}
void reshape(int w,int h)
{ 
	mp.reshape(w,h); 
}
void idle( void )
{   
	bool finished = mp.simulationFinished();
	if (!finished)
	{
		mp.update(); 
		if (mp.qTime % 1 == 0)
			glutPostRedisplay();
	}
	
	//
#ifdef LINUX
	usleep(10);
#endif
#ifdef WIN32
	Sleep(1);
#endif
}

void mouse(int button, int state, int x, int y ){ mp.mouse(button,state,x,y); }
void motion(int x, int y ){mp.motion(x,y); }
void passive(int x, int y ){mp.passivemotion(x,y); }
void keyboard(unsigned char key, int x, int y){
	mp.keyboard(key, x, y); 
	switch (key)
	{
	case 'r':
	case ' ':
		mp.togglePause();
		break;
	case 27:
	case 'x':
		exit(0);
		break;
	}
	//if(key=='r'){ mp.togglePause();}
	//if (key=='x'){exit(0);}
	
}  
int main(int argc, char* argv[]){
	
	
	
	glutInit(&argc, argv);
	mp.m_outStep = 100;
	mp.prepare4Run(2000, 0.001);
	mp.m_TotalSteps = 1000;
	glutCreateWindow(0,0,800,400,"1D FDTD Simulation");
	glutDisplayFunc( display );
	glutReshapeFunc( reshape );
	glutIdleFunc( idle );
	glutMotionFunc( motion );
	glutMouseFunc( mouse );
	glutPassiveMotionFunc(passive);    
	glutKeyboardFunc( keyboard );        
	glutMainLoop();    
	return 0;
} 
